<?php
/*
You may not change or alter any portion of this comment or credits
of supporting developers from this source code or any supporting source code
which is considered copyrighted (c) material of the original comment or credit authors.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * Xoops locale
 *
 * @copyright       (c) 2000-2016 XOOPS Project (www.xoops.org)
 * @license             GNU GPL 2.0 (https://www.gnu.org/licenses/gpl-2.0.html)
 * @package             kernel
 * @since               2.3.0
 * @author              Taiwen Jiang <phppp@users.sourceforge.net>
 * @todo                To be handled by i18n/l10n
 */
defined('XOOPS_ROOT_PATH') or die('禁止存取');

setlocale(LC_ALL, 'zh_TW.UTF-8');

// !!IMPORTANT!! insert '\' before any char among reserved chars: 'a', 'A', 'B', 'c', 'd', 'D', 'F', 'g', 'G', 'h', 'H', 'i', 'I', 'j', 'l', 'L', 'm', 'M', 'n', 'O', 'r', 's', 'S', 't', 'T', 'U', 'w', 'W', 'Y', 'y', 'z', 'Z'
// insert double '\' before 't', 'r', 'n'
define('_TODAY', '今天 G:i');
define('_YESTERDAY', '昨天 G:i');
define('_MONTHDAY', 'n/j G:i');
define('_YEARMONTHDAY', 'Y/n/j G:i');
define('_ELAPSE', '%s 以前');
define('_TIMEFORMAT_DESC', '有效格式： \'s\' - ' . _SHORTDATESTRING . '; \'m\' - ' . _MEDIUMDATESTRING . '; \'l\' - ' . _DATESTRING . ';<br>' . '\'c\' or \'custom\' - format determined according to interval to present; \'e\' - Elapsed; \'mysql\' - Y-m-d H:i:s;<br>' . 'specified string - Refer to <a href=\'https://php.net/manual/en/function.date.php\' rel=\'external\'>PHP manual</a>.');

if (!class_exists('XoopsLocalAbstract')) {
    include_once XOOPS_ROOT_PATH . '/class/xoopslocal.php';
}

/**
 * A Xoops Local
 *
 * @package             kernel
 * @subpackage          Language
 *
 * @author              Taiwen Jiang <phppp@users.sourceforge.net>
 * @copyright       (c) 2000-2016 XOOPS Project (www.xoops.org)
 */
class XoopsLocal extends XoopsLocalAbstract
{
    /**
     * Number Formats
     *
     * @param unknown_type $number
     * @return mixed
     */
    public function number_format($number)
    {
        return number_format($number, 2, '.', ',');
    }

    /**
     * Money Format
     *
     * @param string $format
     * @param string $number
     * @return money format
     */
    public function money_format($format, $number)
    {
        // setlocale(LC_MONETARY, 'zh_TW');
        setlocale(LC_ALL, 'zh_TW.UTF-8');
        return money_format($format, $number);
    }
}
